from django.utils.translation import ugettext_lazy as _

from admin_tools.dashboard import modules

class PbxDashboard(modules.Group):
    def __init__(self, **kwargs):
        kwargs =  {
            'title': "Pbx",
            'display': "tabs",
            'children': [
                PbxModels(),
                RoutingModels(),
                UtentiModels(),
                IvrModels(),
            ]
        }
        super(PbxDashboard, self).__init__(**kwargs)

class PbxModels(modules.ModelList):
    def __init__(self, **kwargs):
        kwargs =  {
            'title': _("Switch"),
            'models': ('pbx.switch.models.Account',
                       'pbx.switch.models.AccountFunctions',
                       'pbx.switch.models.CallGroup',
                       'pbx.switch.models.VoiceMail',
                       'pbx.switch.models.Queue',
                       'pbx.switch.models.QueueMember',
                       'pbx.switch.models.MeetMe',
                       'pbx.switch.models.MeetMeUser',),
        }
        super(PbxModels, self).__init__(**kwargs)

class RoutingModels(modules.ModelList):
    def __init__(self, **kwargs):
        kwargs =  {
            'title': _("Routing"),
            'models': ('pbx.utenti.models.BlacklistEntry',
                       'pbx.utenti.models.PersonalPhonebookEntry',),
        }
        super(RoutingModels, self).__init__(**kwargs)

class UtentiModels(modules.ModelList):
    def __init__(self, **kwargs):
        kwargs =  {
            'title': _("Utenti"),
            'models': ('pbx.routing.models.Rotta',
                       'sctel.prefissi.models.Prefisso',
                       'sctel.prefissi.models.NomeDistretto',
                       'sctel.linee.models.Terminazione'),
        }
        super(UtentiModels, self).__init__(**kwargs)
        
class IvrModels(modules.ModelList):
    def __init__(self, **kwargs):
        kwargs =  {
            'title': _("Ivr"),
            'models': ('pbx.ivr.models.NodoIvr',
                       'pbx.ivr.models.TimeSlot',),
        }
        super(IvrModels, self).__init__(**kwargs)


