# -*- coding: utf-8 -*-
'''
Created on 14/feb/2012

@author: simone cittadini
'''
from django.db import models


TONI = (('0', '0'), ('1', '1'), ('2', '2'), ('3', '3'), ('4', '4'), ('5', '5'),
        ('6', '6'), ('7', '7'), ('8', '8'), ('9', '9'), ('*', '*'), ('#', '#'))

CHOICES_WEEDKAYS = ((0, 'sempre'), (1, 'lunedì'), (2, 'martedì'),
                    (3, 'mercoledì'), (4, 'giovedì'), (5, 'venerdì'),
                    (6, 'sabato'), (7, 'domenica'), (8, 'weekend'))

DICT_WEEKDAYS = {0 : 'sempre',
                 1 : 'lunedì',
                 2 : 'martedì',
                 3 : 'mercoledì',
                 4 : 'giovedì',
                 5 : 'venerdì',
                 6 : 'sabato',
                 7 : 'domenica',
                 8 : 'weekend',}


class FileNodoInRegistrazione(models.Model):
    filename = models.CharField(max_length=32)
    
    @staticmethod
    def get_filename():
        return FileNodoInRegistrazione.objects.all()[0].filename
    
    @staticmethod
    def set_filename(filename):
        try:
            f = FileNodoInRegistrazione.objects.all()[0]
            f.filename = filename
            f.save()
        except:
            FileNodoInRegistrazione.objects.create(filename=filename)
    
class NodoIvr(models.Model):
    nome = models.CharField(max_length=32)
    padre = models.ForeignKey('self', blank=True, null=True)
    tono = models.CharField(max_length=1, choices=TONI, blank=True, null=True)
    filename = models.CharField(max_length=32, unique=True, blank=True,
                                null=True)
    timeout = models.PositiveSmallIntegerField(default=0)
    extension = models.CharField(max_length=32, blank=True, null=True)
    
    
    def __unicode__(self):
        if self.padre:
            p = "(%s ->)" % self.padre.nome
        else:
            try:
                ts = TimeSlot.objects.get(radice=self)
                p = "(%s ->)" % ts
            except:
                p = "(DEFAULT ->)"
        if self.filename:
            a = "play '%s'" % self.filename
        else:
            a = ''
        if self.timeout > 0:
            t = 'after %s seconds' % self.timeout
        else:
            t = ''
        if self.extension:
            e = self.extension
        else:
            e = 'loop'
        return "%s %s, %s call '%s'" % (p, a, t, e)
    
    @property
    def unicode(self):
        return self.__unicode__()
    
    def save(self, *args, **kwargs):
        super(NodoIvr, self).save(*args, **kwargs)
        FileNodoInRegistrazione.set_filename(self.filename)


class TimeSlot(models.Model):
    weekday = models.PositiveIntegerField(default=0, choices=CHOICES_WEEDKAYS)
    inizio = models.TimeField()
    fine = models.TimeField()
    radice = models.ForeignKey(NodoIvr)
    
    def __unicode__(self):
        return "%s , from %s to %s" % (DICT_WEEKDAYS[self.weekday], self.inizio, self.fine)
    
    def save(self, *args, **kwargs):
        super(TimeSlot, self).save(*args, **kwargs)
        #TODO lancio eccezione se mi interseco nel tempo con altro TimeSlot
