# -*- coding: utf-8 -*-
'''
Created on 1/ago/2011

@author: simone cittadini
'''
from django.db import models

from sctel.prefissi.models import NomeDistretto, Prefisso
from sctel.linee.models import Terminazione

class Rotta(models.Model):
    destinazione = models.ForeignKey(NomeDistretto, unique=True)
    terminazione = models.ForeignKey(Terminazione)
    
    class Meta:
        verbose_name_plural = 'Rotte'
        
    def __unicode__(self):
        return "%s - %s" % (self.destinazione.nome, self.terminazione)
    
    @staticmethod
    def get_dial_string(dst):
        prefisso = Prefisso.get_prefisso(dst)
        distretto = prefisso.get_distretto_base()
        try:
            rotta = Rotta.objects.get(destinazione=distretto)
            return rotta.terminazione.get_dial_string(dst)[0]
        except:
            return None
