# -*- coding: utf-8 -*-
'''
Created on 27/gen/2012

@author: simone cittadini
'''
import os, sys
import re
import httplib, urllib
import shlex
import subprocess
import time
import base64
import threading


from lxml import etree
from django.db import models
from django.db.models.query import QuerySet
from django.utils.translation import ugettext_lazy as _
from django.forms import fields
from django.contrib.contenttypes.models import ContentType

from django.template.loader import render_to_string
from jumbo.utils.functions import get_settings

from pbx.utenti.models import UtentePBX
from pbx.switch.models import Account, Device, SERVERURL, SERVERIP

class DevicePolycom(Device):
    
    def save(self, *args, **kwargs):
        super(DevicePolycom, self).save(*args, **kwargs)
        self.create_provision_file()
        
    def create_provision_file(self):
        account = self.account
        utente = account.utentepbx
        user = utente.get_user()
        
        # mac.cfg
        ctx_dict = { 'number' : account.name }
        content = render_to_string('switch/polycom/mac.cfg', ctx_dict)
        file = open("/srv/tftp/%s.cfg" % self.mac_address.replace(':', '').upper(),
                    "w")
        file.write(content)
        file.close()
        
        # phonenum.cfg
        ctx_dict['password'] = account.secret
        content = render_to_string('switch/polycom/phonenum.cfg', ctx_dict)
        file = open("/srv/tftp/phone%s.cfg" % self.account.name,
                    "w")
        file.write(content)
        file.close()
        
    def pre_dial_action(self, cli, exten):
        print >> sys.stderr, "INTO POLYCOM PREDIAL %s %s" % (cli, exten)        
        # se il cli sono io mando ai miei monitoranti la push 
        # allo stato di calling
        try:
            if DevicePolycom.objects.get(account__name=cli) == self:
                print >> sys.stderr, "mi dichiaro calling"
                for u in self.account.utentepbx.osservatori.all():
                    xml = { "XML" : '<CiscoIPPhoneExecute>\
                                     <ExecuteItem URL="%s/switch/cisco_updatestatus_calling/%s/%s/%s/"/>\
                                     </CiscoIPPhoneExecute>' %  (SERVERURL, u.pk, cli, exten)}
                    params = urllib.urlencode(xml)
                    headers = {"TE": "deflate,gzip;q=0.3",
                               "Connection": "TE, close",
                               "Authorization": "Basic YWRtaW46Y2lzY28=",
                               "User-Agent": "thunder-php-ua",
                               }
                    for a in u.accounts_utentepbx.all():
                        print >> sys.stderr, "mando il post a %s" % a.ipaddr
                        conn = httplib.HTTPConnection("%s" % a.ipaddr)
                        conn.request("POST", "/CGI/Execute", params, headers)
        except:
            pass
        # se sono io l'exten chiamata mando ai miei monitoranti la push
        # allo stati di ringing
        try:
            if DevicePolycom.objects.get(account__name=exten) == self:
                print >> sys.stderr, "mi dichiaro ringing"
                for u in self.account.utentepbx.osservatori.all():
                    xml = { "XML" : '<CiscoIPPhoneExecute>\
                                     <ExecuteItem URL="%s/switch/cisco_updatestatus_ringing/%s/%s/%s/"/>\
                                     </CiscoIPPhoneExecute>' %  (SERVERURL, u.pk, cli, exten)}
                    params = urllib.urlencode(xml)
                    headers = {"TE": "deflate,gzip;q=0.3",
                               "Connection": "TE, close",
                               "Authorization": "Basic YWRtaW46Y2lzY28=",
                               "User-Agent": "thunder-php-ua",
                               }
                    for a in u.accounts_utentepbx.all():
                        print >> sys.stderr, "mando il post a %s" % a.ipaddr
                        conn = httplib.HTTPConnection("%s" % a.ipaddr)
                        conn.request("POST", "/CGI/Execute", params, headers)
        except:
            pass
            
    def answer_action(self, cli, exten):
        print >> sys.stderr, "INTO POLYCOM ANSWER %s %s" % (cli, exten)        
        # se sono io l'exten chiamata mando ai miei monitoranti la push
        # allo stato di calling
        try:
            if DevicePolycom.objects.get(account__name=exten) == self:
                print >> sys.stderr, "mi dichiaro calling"
                for u in self.account.utentepbx.osservatori.all():
                    xml = { "XML" : '<CiscoIPPhoneExecute>\
                                    <ExecuteItem URL="%s/switch/cisco_updatestatus_calling/%s/%s/%s/"/>\
                                    </CiscoIPPhoneExecute>' %  (SERVERURL, u.pk, cli, exten)}
                    params = urllib.urlencode(xml)
                    headers = {"TE": "deflate,gzip;q=0.3",
                               "Connection": "TE, close",
                               "Authorization": "Basic YWRtaW46Y2lzY28=",
                               "User-Agent": "thunder-php-ua",
                               }
                    for a in u.accounts_utentepbx.all():
                        print >> sys.stderr, "mando il post a %s" % a.ipaddr
                        conn = httplib.HTTPConnection("%s" % a.ipaddr)
                        conn.request("POST", "/CGI/Execute", params, headers)
        except:
            pass
        
    def post_dial_action(self, cli, exten):
        print >> sys.stderr, "INTO POLYCOM POSTDIAL %s %s" % (cli, exten)        
        # mando ai miei monitoranti la push allo stato di free
        print >> sys.stderr, "mi dichiaro free"
        for u in self.account.utentepbx.osservatori.all():
            xml = { "XML" : '<CiscoIPPhoneExecute>\
                             <ExecuteItem URL="%s/switch/cisco_updatestatus_hanged/%s/%s/%s/"/>\
                             </CiscoIPPhoneExecute>' %  (SERVERURL, u.pk, cli, exten)}
            params = urllib.urlencode(xml)
            headers = {"TE": "deflate,gzip;q=0.3",
                       "Connection": "TE, close",
                       "Authorization": "Basic YWRtaW46Y2lzY28=",
                       "User-Agent": "thunder-php-ua",
                       }
            for a in u.accounts_utentepbx.all():
                print >> sys.stderr, "mando il post a %s" % a.ipaddr
                conn = httplib.HTTPConnection("%s" % a.ipaddr)
                conn.request("POST", "/CGI/Execute", params, headers)
